#!/bin/sh

# Variable
R_DIR=/boot/home/config/settings/NetPositive/Bookmarks
CMD=

HTTP(){
	if [ "`echo $LINE | cut -f3 -d" " | cut -b1-2 | tr -d "\n\r\t "`" != "OK" ]
	then
		addattr "META:Status" "`echo $LINE | cut -f3- -d\" \" | tr -d "\r"`" "$FILE"
		Status=
		return
	fi
	Status="OK"
	addattr "META:Status" "OK" "$FILE"

}

DATE(){
	UPTIME=
	if [ "$Status" = "OK" ]
	then
		UPTIME=`echo $@ | sed -e s/"Date: "/""/ -e s/"Last-Modified: "/""/g | tr -d "\r"`
		addattr "META:Status" "$Status" "$FILE"
		if [ ! -z "$UPTIME" ]
		then
			addattr "META:Last-Modified" "$UPTIME" "$FILE"
		fi
	fi

}

CHECK_CURL(){
	URL=`catattr "META:url" "$1" | sed s/".*: string : "/""/`
	if [ "`echo ${URL} | cut -b 1-4`" != "http" ]
	then
		return
	fi

	curl --head $URL 2>/dev/null | while read LINE
	do
		case `echo $LINE | sed -e s/"\/.*"/""/ -e s/":.*"/""/g -e s/" .*"/""/` in
			HTTP)	HTTP $LINE;;
#			Date)	DATE "$LINE";;
			Last-Modified) DATE "$LINE";;
			*)	;;
		esac
	done
}

CHECK_WGET(){
	URL=`catattr "META:url" "$1" | sed s/".*: string : "/""/`
	if [ "`echo ${URL} | cut -b 1-7`" != "http://" ]
	then
		return
	fi

	wget --spider --server-response $URL 2>&1 | cut -f3- -d" " | while read LINE
	do
		case `echo $LINE | sed -e s/"\/.*"/""/ -e s/":.*"/""/g -e s/" .*"/""/` in
			HTTP)	HTTP $LINE;;
#			Date)	DATE "$LINE";;
			Last-Modified) DATE "$LINE";;
			*)	;;
		esac
	done
}

CMDCHK(){
	curl >/dev/null 2>&1
	if [ "$?" = "2" ]
	then
		CMD="curl"
		return
	fi
	wget >/dev/null 2>&1
	if [ "$?" = "1" ]
	then
		CMD="wget"
		return
	fi

	echo "curl or wget need."
	exit 1
}

# MAIN
CMDCHK

for DIR in `find $R_DIR -type d`
do
	#echo "[DEBUG] DIR $DIR"
	for FILE in $DIR/*
	do
		#echo "[DEBUG] FILE $FILE"
		if [ -d "$FILE" ]
		then
			continue
		fi
		Status=
		if [ "$CMD" = "curl" ]
		then
			CHECK_CURL "$FILE"
		fi
		if [ "$CMD" = "wget" ]
		then
			CHECK_WGET "$FILE"
		fi
	done
done
